;;This function takes a data file and reads the information into an
;;existing block of attributes (block name INFO) to update the isolator assembly schedule.

(defun attfind ()
   (while (= bjatt nil)
      (setq bjatt (ssget "X" (list (cons 0 "INSERT")
                  (cons 2 (getstring "\nBlock name: ")) (cons 66 1))))
   );while
   (setq ofile (open (getstring "\nFILENAME.EXT to read: ") "r"))
   (setq oldprec (getvar "LUPREC"))
   (setvar "LUPREC" 2)
   (setvar "CMDECHO" 0)
 ;this portion reads the the data file and makes lists ready for insertion. 
  (while (setq rlin (read-line ofile))
      (setq bkinfo (gabepars rlin))
      (setq bjsrch (nth 0 bkinfo))
      (setq bkinfo (mapcar 'atof bkinfo))
      (setq botlst (mapcar 'rtos (list (nth 3 bkinfo) (nth 4 bkinfo)
                                  (+ (nth 1 bkinfo) 70.0))))
      (setq #lgth (length bkinfo))
   ;this portion examines the length of the list to determine its position in the block.   
   (cond ((> #lgth 11)
          (if (= (nth 11 bkinfo) 4444)
              (setq cmt1 (list "DEMO"))
              (setq cmt1 (list " "))
          );if
          (if (= (nth 12 bkinfo) 4444)
              (setq cmt2 (list "DEMO" "-" "-" "-" "-"))
              (setq cmt2 (list " " "-" "-" "-" "-"))
          );if
          (setq toplst (mapcar 'rtos (list (nth 8 bkinfo) (nth 9 bkinfo))))
          (setq infolst (append cmt1 botlst toplst cmt2
                         (mapcar 'fix (list (nth 13 bkinfo) (nth 14 bkinfo)
                                        (nth 15 bkinfo)))))
            );1cond
         ((and (> #lgth 7) (< #lgth 12))
          (if (= (nth 6 bkinfo) 4444)
              (setq cmt1 (list "DEMO"))
              (setq cmt1 (list " "))
          );if
          (if (= (nth 7 bkinfo) 4444)
              (setq cmt2 (list "DEMO" "-" "-" "-" "-"))
              (setq cmt2 (list " " "-" "-" "-" "-"))
          );if
      ;this portion assembles the new list.    
      (setq infolst (append cmt1 botlst (mapcar 'rtos (list (nth 3 bkinfo)
                                            (nth 4 bkinfo))) cmt2
                          (mapcar 'fix (list (nth 8 bkinfo) (nth 9 bkinfo)
                                        (nth 10 bkinfo)))))
         );2cond
         ((< #lgth 7)
          (setq botlst (list " " " " " " " " " "))
          (if (= (nth 1 bkinfo) 4444)
              (setq cmt1 (list "DEMO"))
              (setq cmt1 (list " "))
          );if
          (if (= (nth 2 bkinfo) 4444)
              (setq cmt2 (list "DEMO" "-" "-" "-" "-"))
              (setq cmt2 (list " " "-" "-" "-" "-"))
          );if
          (setq infolst (append cmt1 botlst cmt2
                         (mapcar 'fix (list (nth 3 bkinfo) (nth 4 bkinfo)
                                        (nth 5 bkinfo)))))
         );2cond
     );cond
    ;this portion substitutes the new data values into the existing block attributes.
      (setq ctr (1- (sslength bjatt)))
      (while (/= bjsrch #mrk)
         (setq bjblk (cdr (assoc -1 (entget (ssname bjatt ctr)))))
         (setq #mrk (cdr (assoc 1 (entget (entnext bjblk)))))
         (setq ctr (1- ctr))
      );while
      (setq attnam bjblk)
      (repeat 11
         (setq attnam (cdr (assoc -1 (entget (entnext attnam)))))
      );repeat
      (setq wklst (ssadd attnam))
      (repeat 13
         (setq attnam (cdr (assoc -1 (entget (entnext attnam)))))
         (ssadd attnam wklst)
      );repeat
      (command "attedit" "y" "" "" "" wklst)
     (foreach n infolst
        (command "V" "R" n "N")
     );foreach
     (setq infolst nil botlst nil toplst nil)
     (ssdel bjblk bjatt)
   );while
   (setvar "LUPREC" oldprec)
   (princ)
);defun

;This function parses the text files and returns a list containing those values to the vavrious 
(defun GABEPARS (bjlin / bjlen)
   (setq bjlen (strlen bjlin) bjctr 1 bjval "" bjinp nil)
   (repeat bjlen
      (setq bjtem (substr bjlin bjctr 1))
      (cond ((/= bjtem " ")
             (setq bjval (strcat bjval bjtem))
            )
            ((and (= bjtem " ") (/= bjval ""))
             (setq bjinp (append bjinp (list bjval)) bjval "")
            )
      );cond
      (setq bjctr (1+ bjctr))
   );repeat
   (setq bjinp (append bjinp (list bjval)) bjval "")
   bjinp
);defun
